routes/web.php
        Route::get('/download', 'ResourceController@download');
    });

    Route::group(['prefix' => '/collections/{slug}'], function () {
        // show single resource
        Route::get('/', 'CollectionController@show');
    });
});
/***
    Route::prefix('/')->namespace('Auth')->group(function () {
        // show web login form
        Route::get('login', 'LoginController@showLoginForm')->name('login');

        // show web registration form
        Route::get('register', 'LoginController@showRegistrationForm');
        Route::get('register-ok', 'LoginController@showRegistrationSuccess');

        //Password Reset Routes...
        Route::get('password-reset', 'ForgotPasswordController@showLinkRequestForm');
        Route::post('password/email', 'ForgotPasswordController@sendResetLinkEmail')->name('password.email');
        Route::get('password/reset', 'ResetPasswordController@showResetForm')->name('password.reset');
        Route::post('password/resetV2', 'ResetPasswordController@updatePassword')->name('password.update');
    });
*** */
Route::post('password/resetV2', 'Auth\ResetPasswordController@updatePassword')->name('password.update');
    Route::prefix('/')->namespace('Api\V1')->group(function () {

        // login from web by using api
        Route::post('login', 'AuthenticateController@authenticate');

        // logout from web by using api
        Route::post('logout', 'AuthenticateController@logout');
    });

    Route::group(['prefix' => 'users', 'namespace' => 'Api\V1'], function () {

        Route::get('/', 'UserController@index');
        Route::post('/', 'UserController@store');

        // User Methods
        Route::group(['prefix' => '{id}'], function () {

            Route::get('/', 'UserController@show');
            Route::put('/', 'UserController@update');
            Route::delete('/', 'UserController@delete');

            // Get User Profile
            Route::get('profile', 'UserController@getProfile');

            // Update user password
            //Route::post('password/reset', 'Auth\PasswordController@postReset');

            Route::put('profile', 'UserController@updateProfile');
            Route::post('profile/image', 'UserController@updateImage');
            Route::post('password/update', 'UserController@updatePassword');
            Route::delete('profile/image', 'UserController@deleteImage');
            Route::post('/avatar', 'UserController@setAvatar');
            Route::get('/settings', 'UserController@getSettings');
            Route::post('/settings', 'UserController@setSettings');
        });
    });

    Route::group(['prefix' => 'polls', 'namespace' => 'Api\V1'], function () {
        Route::post('/{id}/vote', 'PollController@vote');
        Route::get('/{id}/result', 'PollController@result');
        Route::get('/last', 'PollController@last');

        Route::resource('/', 'PollController');
    });




Route::get('/webapi/resources', 'Api\V1\ResourceController@index');
Route::get('/webapi/resources-by-query', 'Api\V1\ResourceController@getResourcesByQuery');
Route::post('/webapi/resources', 'Api\V1\ResourceController@store');
Route::get('/webapi/resources/latest', 'Api\V1\ResourceController@getLatestResources');
Route::get('/webapi/resources/latest/{id}', 'Api\V1\ResourceController@getLatestResourcesByAuthor');
Route::get('/webapi/resources/ranked/{id}', 'Api\V1\ResourceController@getRankedResourcesByAuthor');
Route::post('/webapi/resources/{id}/like', 'Api\V1\ResourceController@like');
Route::get('/webapi/resources/{id}', 'Api\V1\ResourceController@show');
Route::post('/webapi/resources/{id}', 'Api\V1\ResourceController@updateResource');
Route::post('/webapi/resources/{id}/file', 'Api\V1\ResourceController@updateFileResource');
Route::post('/webapi/resources/{id}/new-update', 'Api\V1\ResourceController@newUpdate');
Route::get('/webapi/resources/{id}/edit', 'Api\V1\ResourceController@edit');
Route::post('/webapi/resources/updateInfo/{id}', 'Api\V1\ResourceController@updateInfo');
Route::post('/webapi/resources/file/delete', 'Api\V1\ResourceController@fileDelete');
Route::get('/webapi/resources/{slug}/download-content', 'Api\V1\ResourceController@downloadContent');
Route::get('/webapi/resources/{slug}/download-attachment', 'Api\V1\ResourceController@downloadAttachment');
Route::post('/webapi/ratings', 'Api\V1\RatingController@setRating');

//Route::get('/webapi/collections/{collection_id}/resources', 'Api\V1\CollectionController@getResources');
Route::get('/webapi/collections/{collection_id}/resources', 'Api\V1\CollectionController@getResourcesByCollection');
Route::post('/webapi/collections/sync/resources', 'Api\V1\CollectionController@syncResources');
Route::get('/webapi/collections/{slug}', 'Api\V1\CollectionController@show');


Route::get('/webapi/tags', 'Api\V1\ResourceController@searchTags');
Route::get('/webapi/author/{id}', 'Api\V1\ResourceController@getAuthor');
Route::get('/webapi/authors', 'Api\V1\ResourceController@searchAuthors');

Route::resource('/tags', 'Api\V1\TagController');

Route::get('/ads', 'Api\V1\ResourceController@getAds');
Route::get('/linker/{uuid}', 'Api\V1\ResourceController@linker');
Route::get('/mailablex', function () {
    return new \App\Mail\UserActivationCode(App\Models\User::find(1));
});
Route::get('/mailable/{email}', function ($email) {
    Mail::raw('Test email', function ($message) use ($email) {
        $message->subject('Testing Mailables')
            ->to($email);
    });
});

Route::get('/launching/{email}', function ($email) {
    Mail::to($email)->send(new \App\Mail\LaunchingV2());
});

/* Route::get('/elasticsearch/{query}', 'ElasticSearchController@search');
Route::resource('/elastic', 'ElasticSearchController'); */


Route::post('/accept', 'Web\HomeController@acceptTerms');
Route::get('/badges', 'Web\HomeController@badges');

//login admin
Route::post('loginAdmin', 'LoginAdminController@loginAdmin');
Route::get('admin_login', 'LoginAdminController@loginAdminView');

Route::get('reset_password', 'ResetPasswordController@index');


Route::group(['prefix' => 'admin', 'namespace' => 'Web'], function() {
    //'middleware' => 'backend',
//oute::group(['prefix' => 'admin', 'namespace' => 'Web','middleware' => 'backend'], function() {
    // Rutas de los controladores dentro del Namespace "App\Http\Controllers\Admin"
    Route::view('/', 'dashboard.index')->name('admin');

    //ads
    Route::resource('/ads', 'AdminAdsController');

    Route::get('/password-reset/token={token}', 'AdminUserController@showEmail');
    //recursos
    Route::get('/recursos/datatables', 'AdminResourceController@getDatatable');
    Route::resource('/recursos', 'AdminResourceController');
    Route::post('/recursos/publishedResources/{id}', 'AdminResourceController@publishedResources');
    Route::post('/recursos/recover/{id}', 'AdminResourceController@recover')->name('recursos.recover');

    //publicamos recurso
    Route::get('/recursos/{id}/status', 'AdminResourceController@togglePublished')->name('recursos.published');

    //usuarios
    Route::get('/usuarios/datatables', 'AdminUserController@getDatatable');
    Route::post('/usuarios/avatar', 'AdminUserController@manageAvatar');
    Route::resource('/usuarios', 'AdminUserController');

    //encuestas
    Route::get('encuestas', 'AdminPollController@index');
    //Route::resource('/encuestas', 'Web\AdminPollController')->middleware('backend');

    Route::resource('/encuestas', 'AdminPollController');
    Route::get('/encuestas/{id}/status', 'AdminPollController@status')->name('encuestas.status');
    Route::get('/encuestas/datatables', 'AdminPollController@getDatatable');

    //collections
    Route::get('/collections/datatables', 'AdminCollectionController@getDatatable');
    Route::get('/collections/resources/{collection_id}', 'AdminCollectionController@resources');
    Route::resource('/collections', 'AdminCollectionController');

    //resource
    //Route::get('/resources/{id}', 'AdminResourceController@edit');
    Route::get('/resources/edit/{resource_id}', 'AdminResourceController@edit');
   // Route::get('resourceEdit','AdminResourceController@edit');
    //notifications
    Route::get('/notifications', 'AdminNotificationController@index')->name('notifications.index');
    Route::get('/notifications/{id}/read', 'AdminNotificationController@markAsRead')->name('notification.read');
    Route::get('/notifications/read', 'AdminNotificationController@markAllAsRead')->name('notification.all.read');
    Route::get('/notifications/unread', 'Web\NotificationController@getUnreadNotifications');

    //gallery
    Route::get('/gallery','GalleryController@index')->name('gallery.index');
    Route::get('/gallery/order','GalleryController@order')->name('gallery.order');
    Route::get('/gallery/datatables','GalleryController@getDatatable');
    Route::get('/gallery/create','GalleryController@create')->name('gallery.create');
    Route::post('/gallery/create','GalleryController@store')->name('gallery.store');
    Route::get('/gallery/edit/{id}','GalleryController@edit')->name('gallery.edit');
    Route::post('/gallery/edit/{id}','GalleryController@update')->name('gallery.update');
    Route::post('/gallery/change/{id}','GalleryController@change')->name('gallery.change');
    Route::post('/gallery/destroy{id}','CategoryController@destroy')->name('gallery.destroy');

    //categories
    Route::get('/categories','CategoryController@list')->name('categories.list');
    Route::get('/categories/datatables', 'CategoryController@getDatatable');
    Route::get('/categories/create','CategoryController@create');
    Route::put('/categories/update/{id}','CategoryController@update');
    Route::post('/categories/store','CategoryController@store');
    Route::get('/categories/{id}','CategoryController@edit');
    Route::post('/categories/edit/{id}','CategoryController@update');
    Route::get('/categories/show/{id}','CategoryController@show');

app/Models/Ad.php
<?php

namespace App\Models;

use App\Models\AdClick;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Support\Facades\Auth;


class Ad extends Model
{
    use SoftDeletes;

    protected $table = 'ads';
    protected $guarded = ['id'];
    protected $appends = ['banner'];

    public function user()
    {
        return $this->belongsTo(User::class);
    }

    public function getBannerAttribute()
    {
        return $this->getFirstMediaUrl('ads');
    }

    public function clicks()
    {
        return $this->hasMany(AdClick::class);
    }

    public function click()
    {
        $this->clicks()->create([
            'user_id' => Auth::id() ?? 0,
            'ad_id' => $this->id,
        ]);
    }
}

resources/views/dashboard/ads/create.blade.php
@extends('layouts.dashboard')

@section('content')
    <div class="container-fluid">
        <div class="row page-titles">
            <div class="col-md-6 col-8 align-self-center">
                {{--<h3 class="text-themecolor mb-0 mt-0">Recursos</h3>--}}
                <ol class="breadcrumb">
                    <li class="breadcrumb-item"><a href="javascript:void(0)">Publicidad</a></li>
                    <li class="breadcrumb-item active">Crear</li>
                </ol>
            </div>
        </div>
        <div class="row">
            <div class="col">
                <div class="card">
                    <div class="card-body">
                        @include('dashboard.partials.flash-message')
                        <h4 class="card-title">Crear publicidad</h4>
                        {{--<h6 class="card-subtitle"> All with bootstrap element classies </h6>--}}
                        <form id="form-create-poll" class="mt-4" action="{{route('ads.store')}}" method="POST"
                              enctype="multipart/form-data">
                            {{csrf_field()}}
                            <div class="form-group">
                                <label>Nombre</label>
                                <input type="text" class="form-control" name="name" aria-describedby="emailHelp"/>
                                @if($errors->has('name'))
                                    <span>{{$errors->first('name')}}</span>
                                @endif
                            </div>
                            <div class="form-group">
                                <label>Descripción</label>
                                <textarea name="description" class="form-control" id="" cols="30" rows="4"></textarea>
                                @if($errors->has('description'))
                                    <span>{{$errors->first('description')}}</span>
                                @endif
                            </div>
                            <div class="row form-group">
                                <div class="form-group col-6">
                                    <label>Fecha de inicio:</label>
                                    <input type="date" name="starts_at" class="form-control">
                                    @if($errors->has('starts_at'))
                                        <span>{{$errors->first('starts_at')}}</span>
                                    @endif
                                </div>
                                <div class="form-group col-6">
                                    <label>Fecha de fin:</label>
                                    <input type="date" name="ends_at" class="form-control">
                                    @if($errors->has('ends_at'))
                                        <span>{{$errors->first('ends_at')}}</span>
                                    @endif
                                </div>
                            </div>
                            <div class="form-group">
                                <label>Enlace de redirección:</label>
                                <input type="text" name="link" class="form-control">
                                @if($errors->has('link'))
                                    <span>{{$errors->first('link')}}</span>
                                @endif
                            </div>
                            <div class="form-group">
                                <label>Banner:</label>
                                <input type="file" name="banner" class="form-control">
                                @if($errors->has('banner'))
                                    <span>{{$errors->first('banner')}}</span>
                                @endif
                            </div>
                            <button type="submit" class="btn btn-primary">Publicar</button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
    @include('dashboard.partials.footer')
@endsection

@section('script')
    <script>
        const app = new Vue({
            el: '#form-create-poll',
            data() {
                return {
                    responses: [],
                    date_from: null,
                    date_to: null,
                }
            },
            mounted() {
                let today = new Date().toISOString().slice(0, 10);
                this.date_from = today;
                this.date_to = today;
            },
            methods: {
                addResponse() {
                    this.responses.push("");
                },
                deleteResponse(key) {
                    this.responses.splice(key, 1);
                },
            },

        });
    </script>
@endsection

resources/views/dashboard/ads/edit.blade.php
@extends('layouts.dashboard')

@section('content')
    <div class="container-fluid">
        <div class="row page-titles">
            <div class="col-md-6 col-8 align-self-center">
                {{--<h3 class="text-themecolor mb-0 mt-0">Recursos</h3>--}}
                <ol class="breadcrumb">
                    <li class="breadcrumb-item"><a href="javascript:void(0)">Publicidad</a></li>
                    <li class="breadcrumb-item active">Edición</li>
                </ol>
            </div>
        </div>
        <div class="row">
            <div class="col">
                <div class="card">
                    <div class="card-body">
                        <h4 class="card-title">Editar publicidad</h4>
                        {{--<h6 class="card-subtitle"> All with bootstrap element classies </h6>--}}
                        <form id="form-create-poll" class="mt-4" action="{{route('ads.update', $ad->id)}}" method="POST"
                              enctype="multipart/form-data">
                            {{csrf_field()}}
                            {{method_field('PUT')}}
                            <div class="form-group">
                                <label>Nombre</label>
                                <input type="text" class="form-control" name="name" aria-describedby="emailHelp"
                                       value="{{$ad->name}}"/>
                                @if($errors->has('name'))
                                    <span>{{$errors->first('name')}}</span>
                                @endif
                            </div>
                            <div class="form-group">
                                <label>Descripción</label>
                                <textarea name="description" class="form-control" id="" cols="30" rows="4">
                                    {{$ad->description}}
                                </textarea>
                                @if($errors->has('description'))
                                    <span>{{$errors->first('description')}}</span>
                                @endif
                            </div>
                            <div class="row form-group">
                                <div class="form-group col-6">
                                    <label>Fecha de inicio:</label>
                                    <input type="date" name="starts_at" class="form-control" value="{{$ad->starts_at}}">
                                    @if($errors->has('starts_at'))
                                        <span>{{$errors->first('starts_at')}}</span>
                                    @endif
                                </div>
                                <div class="form-group col-6">
                                    <label>Fecha de terminación:</label>
                                    <input type="date" name="ends_at" class="form-control" value="{{$ad->ends_at}}">
                                    @if($errors->has('ends_at'))
                                        <span>{{$errors->first('ends_at')}}</span>
                                    @endif
                                </div>
                            </div>
                            <div class="form-group">
                                <label>Enlace</label>
                                <input type="text" name="link" class="form-control" value="{{$ad->link}}">
                                @if($errors->has('link'))
                                    <span>{{$errors->first('link')}}</span>
                                @endif
                            </div>
                            <div class="form-group">
                                <label>Banner</label>

                                <div class="row">
                                    <div class="col-sm-6 offset-sm-3">
                                       {{-- <img src="{{$ad->banner}}" width="100%" class="mx-auto">--}}
                                    </div>
                                </div>

                                <input type="file" name="banner" class="form-control">
                                @if($errors->has('banner'))
                                    <span>{{$errors->first('banner')}}</span>
                                @endif
                            </div>
                            <button type="submit" class="btn btn-primary">Actualizar</button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
        <!-- Row -->

    </div>
    @include('dashboard.partials.footer')
@endsection

resources/views/dashboard/ads/index.blade.php
@extends('layouts.dashboard')

@section('content')
    <div class="container-fluid">
        <div class="row page-titles">
            <div class="col-md-6 col-8 align-self-center">
                {{--<h3 class="text-themecolor mb-0 mt-0">Recursos</h3>--}}
                <ol class="breadcrumb">
                    <li class="breadcrumb-item"><a href="javascript:void(0)">Ads</a></li>
                    <li class="breadcrumb-item active">Listado</li>
                </ol>
            </div>
        </div>
        <div class="row">
            <div class="col">
                <div class="card">
                    <div class="card-body">
                        @include('dashboard.partials.flash-message')
                        <h4 class="card-title">Listado de ads</h4>
                       <table id="example" class="table table-striped table-bordered" style="width: 100%;">
                            <thead>
                            <tr>
                                <th>Nombre</th>
                                <th>Descripción</th>
                                <th>Link</th>
                                <th>Clicks</th>
                                <th>Impresiones</th>
                                <th>Fecha</th>
                            </tr>
                            </thead>
                            <tbody>
                            @foreach($ads as $ad)
                                <tr>
                                    <td>{{$ad->name}}</td>
                                    <td>{{$ad->description}}</td>
                                    <td>{{$ad->link}}</td>
                                    <td>{{$ad->clicks()->count()}}</td>
                                    <td>{{$ad->impressions}}</td>
                                    <td>
                                        <a class="btn btn-primary btn-sm" href="{{route('ads.edit', $ad->id)}}">
                                            <i class="mdi mdi-table-edit"></i>
                                        </a>
                                        <form action="{{route('ads.destroy', $ad->id)}}" method="POST"
                                              style="display: inline-block">
                                            {{csrf_field()}}
                                            {{method_field('delete')}}
                                            <button class="btn btn-danger btn-sm"><i class="mdi mdi-delete"></i>
                                            </button>
                                        </form>
                                    </td>
                                </tr>
                            @endforeach
                            </tbody>
                        </table>
                        {{$ads->links()}}
                        <div class="clearfix"></div>
                    </div>
                </div>
            </div>
        </div>
        <!-- Row -->

    </div>
    @include('dashboard.partials.footer')
@endsection
@section('script')
    <script>
 $("#exampleModal").modal("show"); $("#exampleModal").css("z-index", "1042");
</script>

<link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.21/css/dataTables.bootstrap4.min.css" defer/>
<script src="https://cdn.datatables.net/1.10.21/js/jquery.dataTables.min.js" defer ></script>
<script src="https://cdn.datatables.net/1.10.21/js/dataTables.bootstrap4.min.js" defer></script>
<script type="text/javascript">
  $(document).ready( function () {
    $('#example').DataTable();
} );
</script>
@endsection